<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ben
 * Date: 3/12/15
 * Time: 11:26 PM
 * To change this template use File | Settings | File Templates.
 */
class DSCF_DDL_DripLists_Main extends DSCF_DDL_StandardMain{

    static $classname = "DSCF_DDL_DripLists_Main";

    const CURRENT_VERSION = 1;

    const PAGE_HOME = "home";
    const PAGE_ITEMS = "items";
    const PAGE_LISTS = "lists";
    const PAGE_SETTINGS = "settings";
    const PAGE_TOOLS = "tools";

    const SC_ID_LIST_ALL_QUIZZES = 1;
    const SC_ID_INSERT_QUIZ = 2;

    const CRON_HOOK_CONTENT_CHECK = "ddl_content_check_cron_hook";

    /*
    * WordPress Action Hook for init :: Generally the first action available to the Plugins
    */
    public static function wpActionInit(){
        parent::wpActionInit();

        // Add CSS and JS Resources
        //self::addResourceToEnqueue($keyname, $url, $type);

        // Add AJAX Handlers
        //self::addAjaxMapping($name, $callable, $type);

        // Add CRON Hooks
        self::addCronHandler(self::CRON_HOOK_CONTENT_CHECK, array( 'DSCF_DDL_DripLists_Main', 'cronHookContentCheck' ), 'twicedaily');

        // Add Widgets
        //self::addWidget($classname);

        // Add Custom post types
        //self::addCustomPostType( $keyname , $classname );

        // Add MetaBox
        //self::addMetaBox( $classname );

        // Add ShortCode
        //self::addShortcode($shortcode_id, $callable);

        // Random Filters, etc
        //add_filter('filter', $callable);

    }

    public static function wpActionAdminMenu(){
        //add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function, $icon_url, $position );
        //add_menu_page( 'Quick Quizzes', 'Quick Quizzes', 'manage_options', DSCF_DDL_Utilities::buildPageSlug(self::PAGE_HOME), array('DSCF_DDL_Utilities','renderPage') );
        add_menu_page( 'Drip Lists', 'Drip Lists', 'manage_options', DSCF_DDL_Utilities::buildPageSlug(self::PAGE_LISTS), array('DSCF_DDL_Utilities','renderPage') );

        //add_submenu_page( $parent_slug, $page_title, $menu_title, $capability, $menu_slug, $function);
        add_submenu_page( DSCF_DDL_Utilities::buildPageSlug(self::PAGE_LISTS), 'Lists', 'Lists', 'manage_options', DSCF_DDL_Utilities::buildPageSlug(self::PAGE_LISTS), array('DSCF_DDL_Utilities','renderPage'));
        add_submenu_page( DSCF_DDL_Utilities::buildPageSlug(self::PAGE_LISTS), 'Items', 'Items', 'manage_options', DSCF_DDL_Utilities::buildPageSlug(self::PAGE_ITEMS), array('DSCF_DDL_Utilities','renderPage'));
        add_submenu_page( DSCF_DDL_Utilities::buildPageSlug(self::PAGE_LISTS), 'Settings', 'Settings', 'manage_options', DSCF_DDL_Utilities::buildPageSlug(self::PAGE_SETTINGS), array('DSCF_DDL_Utilities','renderPage'));
        //add_submenu_page( DSCF_DDL_Utilities::buildPageSlug(self::PAGE_QUIZZES), 'Tools', 'Tools', 'manage_options', DSCF_DDL_Utilities::buildPageSlug(self::PAGE_TOOLS), array('DSCF_DDL_Utilities','renderPage'));

        // Any hidden but useful pages
    }

    // Database Install Routine
    public static function installDatabase(){
        global $wpdb;

        // Get the DB CharSet
        $charset_collate = $wpdb->get_charset_collate();

        $sql = "";

        // Setup the Basic Item Content Table
        $tt_table_name = DSCF_DDL_DripLists_Item::getTableName();
        $sql .= "
            CREATE TABLE $tt_table_name (
                id int(11) NOT NULL AUTO_INCREMENT,
                blogId BIGINT(20),
                data mediumblob,
                UNIQUE KEY id (id)
            ) $charset_collate;
            ";

        // Setup the Topic DB
        DSCF_DDL_ZoneManager::installDatabase();

        // Run the SQL
        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );

        // Add an option to store the version number
        add_option( DSCF_DDL_Utilities::buildDatabaseVersionString(), self::CURRENT_VERSION );
    }

    public static function buildSettingsEditorOptions($object=null){

        $options[]=array(
            'rowType'=>'SectionHeader',
            'title'=>'Global Framework Settings',
        );
        $keyname = self::SETTINGS_PLUGIN_ENABLED;
        $options[]=array(
            'title'=>'Plugin Enabled',
            'objectType'=>DSCF_DDL_StandardEditor::OT_BOOLEAN,
            'objectName'=>$keyname,
            'formType'=>DSCF_DDL_StandardEditor::ET_CHECKBOX,
            'value'=>(isset($object->$keyname))?$object->$keyname:true,
            'help'=>'True to enable the Plugin, False to disable it without uninstalling it.  If False, will prevent the creation of new content, etc...  Use this feature to disable the plugin globally without having to uninstall it.'
        );

        return $options;

    }

}
