<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ben
 * Date: 5/19/15
 * Time: 9:23 PM
 * To change this template use File | Settings | File Templates.
 */

if ( ! defined( 'ABSPATH' ) ) exit();	// sanity check

// Setup the Add Define Routine
if(!function_exists("dimbal_add_define")){
    function dimbal_add_define($key, $val) {
        if (!defined($key)) {
            define($key, $val);
            return true;
        }
        return false;
    }
}

// Define the Constants to control which classes are loaded
dimbal_add_define('WPDEVHUB_CONST_DDL_CLASSES_ZONES', false);
dimbal_add_define('WPDEVHUB_CONST_DDL_CLASSES_TAGS', false);
dimbal_add_define('WPDEVHUB_CONST_DDL_CLASSES_VIRTUAL_PAGES', false);
dimbal_add_define('WPDEVHUB_CONST_DDL_CLASSES_BROWSER', false);
dimbal_add_define('WPDEVHUB_CONST_DDL_CLASSES_DIMBALCOM', false);
dimbal_add_define('WPDEVHUB_CONST_DDL_CLASSES_METABOX', false);
dimbal_add_define('WPDEVHUB_CONST_DDL_CLASSES_CHART', false);

/********** INCLUDES **********/
$classes = array();

// Core Files
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_Utilities.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardObjectRecord.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardGroupRecord.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardLinkRecord.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardMain.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardCustomPostType.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_Box.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardManager.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_MessagePopup.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardEditor.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardSetting.php';
$classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_ClientDashboardAssistant.php';

// Dimbal Com
if(WPDEVHUB_CONST_DDL_CLASSES_DIMBALCOM){
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_ComRequest.php';
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_ComDispatch.php';
}

// Zone Manager
if(WPDEVHUB_CONST_DDL_CLASSES_ZONES){
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_ZoneManager.php';
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_Zone.php';
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_ZoneItem.php';
}

// Tag Manager
if(WPDEVHUB_CONST_DDL_CLASSES_TAGS){
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardTagManager.php';
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardTag.php';
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardTagItem.php';
}

// Virtual Pages
if(WPDEVHUB_CONST_DDL_CLASSES_VIRTUAL_PAGES){
    $classes[] = dirname(__FILE__).'/../classes/interface.DSCF_DDL_VirtualPages_PageInterface.php';
    $classes[] = dirname(__FILE__).'/../classes/interface.DSCF_DDL_VirtualPages_ControllerInterface.php';
    $classes[] = dirname(__FILE__).'/../classes/interface.DSCF_DDL_VirtualPages_TemplateLoaderInterface.php';
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_VirtualPages_Page.php';
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_VirtualPages_Controller.php';
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_VirtualPages_TemplateLoader.php';
}

// Browser Helper
if(WPDEVHUB_CONST_DDL_CLASSES_BROWSER){
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_Browser.php';
}

// Browser Helper
if(WPDEVHUB_CONST_DDL_CLASSES_METABOX){
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardMetaBox.php';
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardMetaBoxAndDbObject.php';
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_StandardMetaBoxObject.php';
}

// Browser Helper
if(WPDEVHUB_CONST_DDL_CLASSES_CHART){
    $classes[] = dirname(__FILE__).'/../classes/class.DSCF_DDL_Chart.php';
}

// Update Checker
$classes[] = dirname(__FILE__).'/../lib/plugin-update-checker/plugin-update-checker.php';

foreach($classes as $classpath){
    include($classpath);
}

// Setup Virtual Page Hook Controller
if(WPDEVHUB_CONST_DDL_CLASSES_VIRTUAL_PAGES){
    $virtualPageController = new DSCF_DDL_VirtualPages_Controller( new DSCF_DDL_VirtualPages_TemplateLoader() );
    add_action( 'init', array( $virtualPageController, 'init' ) );
    add_filter( 'do_parse_request', array( $virtualPageController, 'dispatch' ), PHP_INT_MAX, 2 );
    add_action( 'loop_end', function( \WP_Query $query ) {
        if ( isset( $query->virtual_page ) && ! empty( $query->virtual_page ) ) {
            $query->virtual_page = NULL;
        }
    } );
    add_filter( 'the_permalink', function( $plink ) {
        global $post, $wp_query;

        if (
            $wp_query->is_page
            && isset( $wp_query->virtual_page )
            && ($wp_query->virtual_page instanceof DSCF_DDL_VirtualPages_Page)
            && isset( $post->is_virtual )
            && $post->is_virtual
        ) {
            $plink = home_url( $wp_query->virtual_page->getUrl() );
        }
        return $plink;
    } );
}



// Base Constants that should be overridden
dimbal_add_define('WPDEVHUB_CONST_DDL_APP_CODE', 'undefined');
dimbal_add_define('WPDEVHUB_CONST_DDL_SLUG', 'wpdevhub-'.WPDEVHUB_CONST_DDL_APP_CODE);
dimbal_add_define('WPDEVHUB_CONST_DDL_DB_PREFIX', 'wpdevhub-'.WPDEVHUB_CONST_DDL_APP_CODE);
dimbal_add_define('WPDEVHUB_CONST_DDL_PAGE_PREFIX', WPDEVHUB_CONST_DDL_SLUG);                   // Deprecate this one
dimbal_add_define('WPDEVHUB_CONST_DDL_SETTINGS_PREFIX', WPDEVHUB_CONST_DDL_SLUG.'-');
dimbal_add_define('WPDEVHUB_CONST_DDL_URL', WP_PLUGIN_URL . '/' . WPDEVHUB_CONST_DDL_SLUG);
dimbal_add_define('WPDEVHUB_CONST_DDL_DIR', WP_PLUGIN_DIR . '/' . WPDEVHUB_CONST_DDL_SLUG);
dimbal_add_define('WPDEVHUB_CONST_DDL_URL_IMAGES', WPDEVHUB_CONST_DDL_URL . '/images');
dimbal_add_define('WPDEVHUB_CONST_DDL_PLUGIN_FILE', WPDEVHUB_CONST_DDL_DIR . '/index.php');
dimbal_add_define('WPDEVHUB_CONST_DDL_USE_UPDATER',true);
dimbal_add_define('WPDEVHUB_CONST_DDL_PROMO_DCD',true);       // Safety switch to turn off promo'ing.
dimbal_add_define('WPDEVHUB_CONST_DDL_URL_SUBSCRIPTIONS', 'https://www.wpdevhub.com/subscriptions/');

// Pages
dimbal_add_define('WPDEVHUB_CONST_DDL_PAGE_HOME', 'home');
dimbal_add_define('WPDEVHUB_CONST_DDL_PAGE_ZONES', 'zones');
dimbal_add_define('WPDEVHUB_CONST_DDL_PAGE_SETTINGS', 'settings');
dimbal_add_define('WPDEVHUB_CONST_DDL_PAGE_REPORTS', 'reports');
dimbal_add_define('WPDEVHUB_CONST_DDL_PAGE_PREVIEW', 'preview');
dimbal_add_define('WPDEVHUB_CONST_DDL_PAGE_SUPPORT', 'support');


// Zones
dimbal_add_define('WPDEVHUB_CONST_DDL_ZONE_GROUP_NAME', 'Zone');
dimbal_add_define('WPDEVHUB_CONST_DDL_ZONE_ITEM_NAME', 'Item');

// Environment Specific Loading
include dirname(__FILE__).'/inc.env.php';
include dirname(__FILE__).'/inc.ver.php';


// Setup the Update Routines
// For speed - Only do if we are in admin and user can actually do updates
if ( is_admin() ) {

    //

    // Make sure the admin functions are available -- otherwise it breaks on is_plugin_active
    include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

    // Setup the Dimbal Updater if Applicable
    if(WPDEVHUB_CONST_DDL_USE_UPDATER){

        $myUpdateChecker = PucFactory::buildUpdateChecker(
            WPDEVHUB_CONST_DDL_WDH_SERVICES_BASE_URL.'/client/version-check/?plugin_code='.WPDEVHUB_CONST_DDL_SLUG.'&level='.WPDEVHUB_CONST_DDL_LEVEL,
            WPDEVHUB_CONST_DDL_PLUGIN_FILE,
            WPDEVHUB_CONST_DDL_SLUG
        );

    }

    // Modify the Updater links accordingly
    //add_action('admin_init', array('DSCF_DDL_ClientDashboardAssistant', 'registerUpdaterFilters'));

}
