/**
 * Created with JetBrains PhpStorm.
 * User: admin
 * Date: 3/24/17
 * Time: 3:36 PM
 * To change this template use File | Settings | File Templates.
 */

// Jquery routine to initialize the Dimbal Object
jQuery(document).ready(function($) {
    DSCF_DDL_Banner_Admin.initialize();
});

var DSCF_DDL_Banner_Admin = {

    initialized:false,
    slug:"WPDEVHUB_CONST_DDL_SLUG",
    url_root:"",
    url_ajax:"",
    url_ajax_load:"",

    initialize:function() {
        // Setup the URLS
        this.url_root = dimbal_dbm_vars.url;
        this.url_ajax = dimbal_dbm_vars.ajax_url;
        this.url_ajax_load = this.url_root+"/images/loading2.gif";
    },

    widgetChangeType:function(elemId, typeId) {
        //console.log("Widget Change Type: elemId["+elemId+"] typeId["+typeId+"]");
        jQuery('.dimbal_dbm_widget_wrapper_'+elemId).hide();
        var elementName = elemId+"_"+typeId;
        //console.log("Final Element Name: "+elementName);
        jQuery("."+elementName).show();
    },

    reportsPollAnalysis:function(){

        // Add a loading routine to the Reports view
        console.log("DSCF_DDL_Banner_Admin.url_ajax_load: "+DSCF_DDL_Banner_Admin.url_ajax_load);
        jQuery("#reportResponse").html("<div style='text-align:center;'><img src='"+dimbalPoll.url_ajax_load+"' /></div>");

        var e = document.getElementById("pollId");
        var pollId = e.options[e.selectedIndex].value;

        // Get the data from the server
        var queryParams = {
            action: dimbalPoll.slug+"-admin-poll-analysis",
            pollId: pollId
        };

        //Now make the Ajax Request
        jQuery.post(dimbalPoll.url_ajax, queryParams, function( response ){
            dimbalPoll.reportsPollAnalysisResponse( response );
        });
    },

    reportsPollAnalysisResponse:function(response){

        if(response == undefined){
            // Bad response
            console.log("Bad Data inside displayPollResponse");
            jQuery("#reportResponse").html("<p>No valid data returned.  Selected poll may not active, valid or have any results yet.</p>");
        }else{

            if(response.pollObject == undefined){
                jQuery("#reportResponse").html("<p>No valid poll data returned.  Selected poll may not be active, valid or have any results yet.</p>");
            }else{

                // Setup main objects
                var pollObject = response.pollObject;
                var wrapperId = "dimbal_chart_poll_id_"+pollObject.id;
                jQuery("#reportResponse").html('<div id="'+wrapperId+'"></div>');

                /*
                 var pollTableData = [];
                 pollTableData.push(['Property', 'Value']);
                 pollTableData.push(['Text', pollObject.text]);
                 pollTableData.push(['Created Date', pollObject.createdDate]);
                 pollTableData.push(['Last Hit Date', pollObject.lastHitDate]);
                 pollTableData.push(['Hit Count', ''+pollObject.hitCount]);
                 pollTableData.push(['Response Count', pollObject.responseCount]);
                 pollTableData.push(['Answer Choices', pollObject.choices.length]);


                 // Setup the Left Table and add to the To Do list
                 var pollTable = new dimbalChartObject();
                 pollTable.type = 3;
                 pollTable.elemId = wrapperId+'_poll_table';
                 pollTable.data = pollTableData;
                 pollTable.options = {sort:'disable', width:'100%'};
                 jQuery("#"+wrapperId).append('<div id="'+pollTable.elemId+'" class="ddl-charts-wrapper-half"></div>');
                 DSCF_DDL_Charts.chartsToDo.push(pollTable);
                 */

                if(response.responseCounts != undefined){
                    // Response Count analysis is provided -- make the graphs
                    var responseCounts = response.responseCounts;

                    //console.log("Response Counts");
                    //console.dir(responseCounts);

                    // Format Google Data
                    var googleDataArray = [];
                    googleDataArray.push(['Poll', 'Response Count']);
                    for (var i in responseCounts) {
                        var responseCount = responseCounts[i];

                        //console.log("Response Count Object");
                        //console.dir(responseCount);
                        if(responseCount != undefined){
                            if(responseCount.text != undefined && responseCount.answers != undefined){
                                googleDataArray.push([responseCount.text, responseCount.answers]);
                            }
                        }

                    }

                    // Setup the Response Distribution Pie Chart and add to the ToDo list
                    var pieChart = new dimbalChartObject();
                    pieChart.type = 1;
                    pieChart.elemId = wrapperId+'_dist_pie_chart';
                    pieChart.data = googleDataArray;
                    pieChart.options = {title:'Response Distribution by Answer Choice'};
                    jQuery("#"+wrapperId).append('<div id="'+pieChart.elemId+'" class="ddl-charts-wrapper-half"></div>');
                    DSCF_DDL_Charts.chartsToDo.push(pieChart);


                    // Setup Options for Response Count Bar Chart
                    var barChart = new dimbalChartObject();
                    barChart.type = 2;
                    barChart.elemId = wrapperId+'_count_bar_chart';
                    barChart.data = googleDataArray;
                    barChart.options = {title:'Response Counts by Answer Choice',legend:'none',chartArea: {left:'30%', width: '60%'}};
                    jQuery("#"+wrapperId).append('<div id="'+barChart.elemId+'" class="ddl-charts-wrapper-half"></div>');
                    DSCF_DDL_Charts.chartsToDo.push(barChart);

                }

                if(response.responseDates != undefined){
                    // Response Dates analysis is provided -- make the graphs

                    var responseDates = response.responseDates;

                    //console.log("Response Dates");
                    //console.dir(responseDates);

                    googleDataArray = [];
                    googleDataArray.push(['Date', 'Qty']);

                    for (var date in responseDates) {
                        var count = responseDates[date];
                        var dateToUse = new Date(date*1000);
                        googleDataArray.push([dateToUse, count]);

                    }

                    //console.log("Annotation Data");
                    //console.dir(googleDataArray);

                    // Setup Options for Response Count Bar Chart
                    var annotationChart = new dimbalChartObject();
                    annotationChart.type = 4;
                    annotationChart.elemId = wrapperId+'_response_annotation_chart';
                    annotationChart.data = googleDataArray;
                    annotationChart.options = {title:'Response Counts Over Time'};
                    jQuery("#"+wrapperId).append('<div id="'+annotationChart.elemId+'" class="ddl-charts-wrapper-full" style="min-height:300px"></div>');
                    DSCF_DDL_Charts.chartsToDo.push(annotationChart);

                }

            }

            // Queue up the Chart Display
            DSCF_DDL_Charts.drawGoogleCharts();
        }

    },

}
